class Button {
  String rectOrCircle;
  float x;
  float y;
  float w;
  float h;
  boolean status;
  color pressedColor;
  color hoverColor;
  color onColor;
  color offColor;
  //PImage activeImg, hoverImg, inactiveImg;

  Button (String _rectOrCircle, 
    float _x, 
    float _y, 
    float _w, 
    float _h, 
    boolean _status, 
    color _pressedColor, 
    color _hoverColor, 
    color _onColor, 
    color _offColor) 
  {
    rectOrCircle = _rectOrCircle;
    x = _x;
    y = _y;
    w = _w;
    h = _h;
    status = _status;
    pressedColor = _pressedColor;
    hoverColor = _hoverColor;
    onColor = _onColor;
    offColor = _offColor;
  }

  void draw() {
    noStroke();
    if (this.mouseOnButton()) {
      if (mousePressed) {
        if (status)
          fill(onColor);
        else 
        fill(offColor);
      } else fill(hoverColor);
    } else {
      if (status) fill (onColor);
      else fill(offColor);
    }
    if (rectOrCircle.equals("rectangle")) {
      rectMode(CENTER);
      rect(x, y, w, h);
    } else if (rectOrCircle.equals("circle"))
    {
      ellipse(x, y, w, h);
    }
  }

  //  Button setActiveImg (PImage aImg) {
  //    activeImg = aImg;
  //    return this;
  //  }
  //  Button setHoverImg (PImage hImg) {
  //    hoverImg = hImg;
  //    return this;
  //  }
  //  Button setInactiveImg (PImage iImg) {
  //    activeImg = iImg;
  //    return this;
  //  }

  boolean mouseOnButton() {
    return (between(mouseX, x-w/2, x+w/2) && between(mouseY, y-h/2, y+h/2));
  }

  void setStatus(boolean _status) {
    status = _status;
  }
  void changeStatus() {
    status = !status;
  }
}

boolean between(float a, float b, float c ) {
  return ((a>=b)&&(a<=c)) || ((a>=c)&&(a<=b));
}